<template>
  <b-card
    :title="star.englishName"
    :img-src="require(`~/assets/${image}.png`)"
    :img-alt="star.id"
    img-top
    tag="div"
    style="max-width: 20rem;"
    class="mb-3"
  >
    <b-card-text>
      {{ star.englishName }} is
      {{ star.isPlanet ? "a planet" : "not a planet" }}.
      <span v-if="star.isPlanet"
        >{{ star.englishName }} has actually
        {{ star.moons === null ? "0" : star.moons.length }} moon(s).</span
      >
      {{ star.englishName }} was discovered by
      {{ star.discoveredBy !== "" ? star.discoveredBy : "an unknow person" }}.
    </b-card-text>

    <div class="row">
      <div class="col-md-9">
        <NuxtLink :to="'/stars/' + star.id">
          <b-button variant="primary">More details</b-button>
        </NuxtLink>
      </div>
      <div class="col-md-3">
        <Favorite
          :id="star.id"
          :name="star.englishName"
          :favorite="favorite"
          @update="updateFavorite"
        />
      </div>
    </div>
  </b-card>
</template>

<script>
import Favorite from "./../../components/Favorite/Favorite.vue";

export default {
  name: "Card",
  components: {
    Favorite
  },
  data() {
    return {
      favorite: false
    };
  },
  props: {
    star: {
      type: Object,
      default: {}
    }
  },
  computed: {
    image() {
      return this.star["isPlanet"] ? "planets" : "moons";
    }
  },
  methods: {
    updateFavorite(value) {
      this.favorite = value;
    }
  },
  created() {
    const favorites = this.$store.state.favorites.list;
    favorites.map(f => {
      if (f === this.star.id) {
        this.favorite = true;
      }
    });
  }
};
</script>

<style scoped>
.row {
  align-items: center;
}
</style>
